chiark / gitweb /
regress/r1test: Support a `$debug' prefix variable.
[adns.git] / regress / r1test
index 3b2bfdf15125a7d8f649228f22d582cd283da481..533fdabd2d62fd97691d30c4bf9ed5b11bac0fc2 100755 (executable)
@@ -1,25 +1,83 @@
 #!/bin/sh
 # usage: r1test <testcasename>
+# test execution script, for running one test
+#
+#  This file is part of adns, which is
+#    Copyright (C) 1997-2000,2003,2006  Ian Jackson
+#    Copyright (C) 1999-2000,2003,2006  Tony Finch
+#    Copyright (C) 1991 Massachusetts Institute of Technology
+#  (See the file INSTALL for full details.)
+#  
+#  This program is free software; you can redistribute it and/or modify
+#  it under the terms of the GNU General Public License as published by
+#  the Free Software Foundation; either version 2, or (at your option)
+#  any later version.
+#  
+#  This program is distributed in the hope that it will be useful,
+#  but WITHOUT ANY WARRANTY; without even the implied warranty of
+#  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+#  GNU General Public License for more details.
+#  
+#  You should have received a copy of the GNU General Public License
+#  along with this program; if not, write to the Free Software Foundation,
+#  Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
 
 set -e
+: ${srcdir=.}
+mrc=1
+trap 'exit $mrc' 0
+
 casename="$1"
-case="case-$casename"
+case="$srcdir/case-$casename"
 ocase="output-$casename"
 
-exec <"$case.sys"
-read initfile
-read queryargs
+exec 4<"$case.sys"
+read <&4 program initfile initflags
+read <&4 queryargs
 
-initstring="`cat init-$initfile.text`"
+initstring="`cat $srcdir/init-$initfile.text`"
+xinitflagsf=$srcdir/$program-xinitflags.text
+if test -f $xinitflagsf
+then
+       initflags="$initflags `cat $xinitflagsf`";
+else
+       initflags="$initflags /"
+fi
 
 rm -f $ocase.*
 
+EF_DISABLE_BANNER=1
+export EF_DISABLE_BANNER
+
+if test -f "$case.in"
+then
+       exec <"$case.in"
+else
+       exec </dev/null
+fi
+
+playback=./${program}_playback
+if test ! -f $playback
+then
+       printf "SKIPPED-$casename "
+       mrc=5
+       exit
+fi
+
 set +e
-ADNS_TEST_REPORT_FD=3 3>>"$ocase.report" >"$ocase.out" 2>"$ocase.err" \
- ./hplayback "/$initstring" $queryargs
+ADNS_TEST_REPORT_FD=3 ADNS_TEST_IN_FD=4 \
+ 3>>"$ocase.report" 4<&4 >"$ocase.out" 2>"$ocase.err" \
+ $debug $playback $initflags"$initstring" $queryargs
 rc=$?
 set -e
 
+if [ "$rc" = 5 ]
+then
+       printf "SKIPPED-$casename "
+       mrc=5
+       exit
+fi
+
 echo "rc=$rc" >>$ocase.out
 
 failed=false
@@ -29,16 +87,23 @@ do
        then
                :
        else
-               failed=true
+               failwhy="$failwhy WRONG OUTPUT"
        fi
 done
 
-if $failed
+cat <&4 >"$ocase.leftover"
+if egrep . /dev/null "$ocase.leftover"
 then
-       echo >&2 "FAILED $case - WRONG OUTPUT - lines of syscall remaining `wc -l`"
-       exit 2
+       failwhy="$failwhy EXITED EARLY"
 fi
 
-echo -n "$casename "
+if [ "x$failwhy" != x ]
+then
+       scremain="`wc -l <\"$ocase.leftover\"`"
+       echo >&2 "FAILED $case -$failwhy - lines of syscall remaining $scremain"
+       mrc=2
+       exit
+fi
 
-exit 0
+printf "$casename "
+mrc=0